/* proto.h - 07 Jan 09
   Hosts3D - 3D Real-Time Network Monitor
   Copyright (c) 2006-2009  Del Castle

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details. */

#include "common.h"

//UDP packet tracking
struct utrk_type
{
  unsigned short srcpt, dstpt;
  in_addr srcip, dstip;
  bool st;
  time_t ttime;
};

//DNS packet tail
#pragma pack(1)
struct dns_tail
{
  unsigned short qtype, qclas, name, type, clas;
  unsigned int ttl;
  unsigned short len;
  in_addr addr;
};

enum udp_type { src, dst, stm };  //UDP packet type - service, destination, stream

//UDP packet tracking and identification
udp_type udpTrack(pkif_type *pi);

//destroy UDP packet tracking LL
void utrkDestroy();

//get IP address from type A class IN standard query response DNS packet payload
void addrGet(char *data, char *nm, in_addr *ip, unsigned int nlen);
